import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { DormitoryBuilding, DormitoryBuildingParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询宿舍楼栋
 */
export async function pageDormitoryBuilding(params: DormitoryBuildingParam) {
  const res = await request.get<ApiResult<PageResult<DormitoryBuilding>>>(
    MODULES_API_URL + '/dormitory/dormitory-building/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询宿舍楼栋列表
 */
export async function listDormitoryBuilding(params?: DormitoryBuildingParam) {
  const res = await request.get<ApiResult<DormitoryBuilding[]>>(
    MODULES_API_URL + '/dormitory/dormitory-building',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加宿舍楼栋
 */
export async function addDormitoryBuilding(data: DormitoryBuilding) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/dormitory/dormitory-building',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改宿舍楼栋
 */
export async function updateDormitoryBuilding(data: DormitoryBuilding) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/dormitory/dormitory-building',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除宿舍楼栋
 */
export async function removeDormitoryBuilding(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/dormitory/dormitory-building/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除宿舍楼栋
 */
export async function removeBatchDormitoryBuilding(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/dormitory/dormitory-building/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询宿舍楼栋
 */
export async function getDormitoryBuilding(id: number) {
  const res = await request.get<ApiResult<DormitoryBuilding>>(
    MODULES_API_URL + '/dormitory/dormitory-building/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
